#region Copyright Syncfusion Inc. 2001 - 2014
// Copyright Syncfusion Inc. 2001 - 2014. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
namespace ResizeToFitDemo
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using System.Windows;
    using System.Windows.Controls;
    using System.Windows.Data;
    using System.Windows.Documents;
    using System.Windows.Input;
    using System.Windows.Media;
    using System.Windows.Media.Imaging;
    using System.Windows.Navigation;
    using System.Windows.Shapes;
    using Syncfusion.Windows.Shared;
    using Syncfusion.Windows.Controls.Grid;
    using Syncfusion.Windows.GridCommon;

    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : ChromelessWindow
    {
        public Window1()
        {
            InitializeComponent();
            this.InitGrid();
        }

        private void InitGrid()
        {
            this.grid.AllowDragColumns = true;
            this.grid.Model.RowCount = 35;
            this.grid.Model.ColumnCount = 25;
            this.grid.QueryCellInfo += grid_QueryCellInfo;
           
        }

        void grid_QueryCellInfo(object sender, GridQueryCellInfoEventArgs e)
        {
            //throw new NotImplementedException();
            //var size = e.Style.CellModel.CalculatePreferredCellSize(e.Cell.RowIndex, e.Cell.ColumnIndex, e.Style, GridQueryBounds.Width);

            //if (size.Width > grid.ColumnWidths[e.Cell.ColumnIndex])
            //{
            //    grid.ColumnWidths[e.Cell.ColumnIndex] = size.Width;
            //}
            //grid.InvalidateVisual(true);
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            var row = this.grid.CurrentCell.RowIndex;
            var col = this.grid.CurrentCell.ColumnIndex;
            this.grid.Model.ResizeColumnsToFit(GridRangeInfo.Cell(row,col), GridResizeToFitOptions.None);
            this.grid.InvalidateVisual(true);
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            var row = this.grid.CurrentCell.RowIndex;
            var col = this.grid.CurrentCell.ColumnIndex;

            this.grid.Model.ResizeRowsToFit(GridRangeInfo.Cell(row, col), GridResizeToFitOptions.None);
            this.grid.InvalidateVisual(true);
        }      
    }
}
